import 'dart:developer';

import 'package:dio/dio.dart';

class LogInterceptor extends InterceptorsWrapper {
  DateTime timeStart;
  DateTime timeEnd;

  @override
  Future onRequest(RequestOptions options) async {
    timeStart = DateTime.now();
    log('OnRequest [${timeStart}ms] | [${options?.method}] => ${options?.uri}');

    return super.onRequest(options);
  }

  @override
  Future onResponse(Response response) {
    timeEnd = DateTime.now();

    log('OnResponse [${timeRequest}ms] | [${response?.statusCode}] | LENGTH: ${response?.data?.length}');
    return super.onResponse(response);
  }

  @override
  Future onError(DioError err) {
    timeEnd = DateTime.now();
    log('MESSAGE: ${err.error}');
    log(' OnError [${timeRequest}ms] [${err?.response?.statusCode}] | LENGTH ${err?.response?.data}');

    return super.onError(err);
  }

  get timeRequest {
    return (timeStart == null) ? '' : (timeEnd.millisecondsSinceEpoch - timeStart?.millisecondsSinceEpoch);
  }
}
